	$TITLE   Software of DINASENS-200
	$SUBTTL  V1.0 (S&S)

Cseg ;--------------------------------

;  Cofstants values

		ADRDAT  equ     20h

		RESET   equ    020h
		COMSET  equ    0C0h

		CMD51   equ     21h
		REG51   equ    0CEh
		RST51   equ     40h
		CEN51   equ     80h
		DEN51   equ     00h

		SETP1   equ    0FFh

		MSICH0  equ    0C0h
		MSIAD0  equ    080h

		CDMAXI  equ      1h
		HRDTBL  equ    0FFh

		TESTNE  equ    100
		TESTNI  equ    100

;-----------------------------------------------------
		ORG     0h
;%S
Begin:
		jmp     Start
		db      0,0,0,0,0,0,0,0

Start:
		dis     i
		ent0    clk
		call    Init        ; FMS_Dev Initialisation
;
		call    Test        ; Start_Test
;
Loop:                       ;: FMS_Data Input_Output
;
		call    Input       ; FMS_Data Input
		call    Output      ; FMS_Data Output
		jmp     Loop
;------------------------------------------------------
Init:                       ;: FMS_Dev Initialisation
		mov     a,#RESET    ;: RESET51
		outl    P2,a
		mov     R0,#10
I:
		djnz    R0,I

		mov     a,#COMSET   ; Command_Regim
		outl    P2,a


		mov     a,#REG51
		outl    BUS,a

		mov     a,#CMD51
		outl    BUS,a

		ret
;......................................................
Input:                      ;: FMS_Data Input
		mov     R0,#ADRDAT
		mov    @R0,#HRDTBL
		mov     R1,#MSICH0
		mov     R2,#MSIAD0
		mov     R3,#6h

I1:
		inc     R0
		mov     a,R1
		outl    P2,a

		mov     a,R2
		outl    P2,a

		mov     a,#SETP1
		outl    P1,a
L:
		jt1     L
		in      a,P1

		cpl     a
		jnz     I2
		mov     a,#CDMAXI
I2:
		cpl     a
		mov    @R0,a
		inc     R1
		inc     R2
		djnz    R3,I1

		ret
;......................................................
Output:                     ;: FMS_Data Output
		mov     R0,#ADRDAT
		mov     R1,#CEN51
		mov     R2,#DEN51
		mov     R3,#7h

O1:
		mov     a,R1
		outl    P2,a
;O2:
;        ins     a,BUS
;        cpl     a
;        jb0     O2

		mov     a,R2
		outl    P2,a
		mov     a,@R0
		outl    BUS,a

		inc     R0
		djnz    R3,O1

		ret
;------------------------------------------------------
Test:                       ;: Start_Test
		mov     R5,#TESTNE
T0:
		mov     R4,#TESTNI
T1:
		mov     R0,#ADRDAT
		mov    @R0,#HRDTBL
		mov     R1,#0AAh
		mov     R2,#0
		mov     R3,#6

T2:
		inc     R0
		mov     a,R2
		add     a,R1

		mov     R1,a
		mov    @R0,a

		djnz    R3,T2

		call    Output

		djnz    R4,T1
		djnz    R5,T0

		ret
;------------------------------------------------------
;%E
		endS

		end   Begin



